commit 7d5b007c2ec298d018752365ab0dc56d77838b6e
Author: Sjon Hortensius <sjon@hortensius.net>
Date:   Sun Jan 4 12:57:21 2015 +0100

    initial drag/drop WIP, working on backup/restore page

diff --git a/etc/inc/gmirror.inc b/etc/inc/gmirror.inc
index 88261c4fd8..2306771057 100644
--- a/etc/inc/gmirror.inc
+++ b/etc/inc/gmirror.inc
@@ -67,33 +67,39 @@ function gmirror_get_status_single($mirror) {
 function gmirror_html_status() {
 	$mirrors = gmirror_get_status();
 	$output = "";
-	if (count($mirrors) > 0) {
-		$output .= "<tr>\n";
-		$output .= "<th>Name</td>\n";
-		$output .= "<th>Status</td>\n";
-		$output .= "<th>Component</td>\n";
-		$output .= "</tr>\n";
-		foreach ($mirrors as $mirror => $name) {
-			$components = count($name["components"]);
-			$output .= "<tr>\n";
-			$output .= "<td rowspan=\"{$components}\">{$name['name']}</td>\n";
-			$output .= "<td rowspan=\"{$components}\" class=\"listr\">{$name['status']}</td>\n";
-			$output .= "<td>{$name['components'][0]}</td>\n";
-			$output .= "</tr>\n";
-			if (count($name["components"]) > 1) {
-				$morecomponents = array_slice($name["components"], 1);
-				foreach ($morecomponents as $component) {
-					$output .= "<tr>\n";
-					$output .= "<td>{$component}</td>\n";
-					$output .= "</tr>\n";
-				}
-			}
-		}
-	} else {
-		$output .= "<tr><td colspan=\"3\" class=\"listr\">No Mirrors Found</td></tr>\n";
+	if (count($mirrors) < 1) {
+?>
+<div class="alert">
+	<p>No Mirrors Found</p>
+</div>
+<?php
+		return;
 	}
-	// $output .= "<tr><td colspan=\"3\" class=\"listr\">Updated at " . date("F j, Y, g:i:s a") . "</td></tr>\n";
-	return $output;
+
+?>
+<table class="table table-striped">
+	<thead>
+		<tr>
+			<th>Name</td>
+			<th>Status</td>
+			<th>Component</td>
+		</tr>
+	</thead>
+	<tbody>
+<?php foreach ($mirrors as $mirror => $name): ?>
+		<tr>
+			<td rowspan="<?=count($name["components"])?>"><?=$name['name']?></td>
+			<td rowspan="<?=count($name["components"])?>"><?=$name['status']?></td>
+			<td><?=$name['components'][0]?></td>
+		</tr>
+<?php if (count($name["components"]) > 1): ?>
+		<?php foreach (array_slice($name["components"], 1) as $component): ?>
+			<tr>
+				<td><?=$component?></td>
+			</tr>
+		<?php endforeach; ?>
+	<?php endif; ?>
+<?php endforeach;
 }
 
 /* List all disks in the system (potential gmirror targets) */
diff --git a/usr/local/www/carp_status.php b/usr/local/www/carp_status.php
index 83975b37c1..214c4a6271 100644
--- a/usr/local/www/carp_status.php
+++ b/usr/local/www/carp_status.php
@@ -1,30 +1,30 @@
 <?php
 /*
-    carp_status.php
-    Copyright (C) 2004 Scott Ullrich
-    Copyright (C) 2013-2014 Electric Sheep Fencing, LP
-    All rights reserved.
-
-    Redistribution and use in source and binary forms, with or without
-    modification, are permitted provided that the following conditions are met:
-
-    1. Redistributions of source code must retain the above copyright notice,
-       this list of conditions and the following disclaimer.
-
-    2. Redistributions in binary form must reproduce the above copyright
-       notice, this list of conditions and the following disclaimer in the
-       documentation and/or other materials provided with the distribution.
-
-    THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
-    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
-    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
-    AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
-    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-    POSSIBILITY OF SUCH DAMAGE.
+	carp_status.php
+	Copyright (C) 2004 Scott Ullrich
+	Copyright (C) 2013-2014 Electric Sheep Fencing, LP
+	All rights reserved.
+
+	Redistribution and use in source and binary forms, with or without
+	modification, are permitted provided that the following conditions are met:
+
+	1. Redistributions of source code must retain the above copyright notice,
+	   this list of conditions and the following disclaimer.
+
+	2. Redistributions in binary form must reproduce the above copyright
+	   notice, this list of conditions and the following disclaimer in the
+	   documentation and/or other materials provided with the distribution.
+
+	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
+	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
+	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
+	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+	POSSIBILITY OF SUCH DAMAGE.
 */
 
 ##|+PRIV
@@ -100,116 +100,85 @@ $carp_detected_problems = ((get_single_sysctl("net.inet.carp.demotion")) > 0);
 $pgtitle = array(gettext("Status"),gettext("CARP"));
 $shortcut_section = "carp";
 include("head.inc");
-
 ?>
-
-<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
-<?php include("fbegin.inc"); ?>
+<body>
+<?php include("fbegin.inc")?>
 <form action="carp_status.php" method="post">
-<?php if ($savemsg) print_info_box($savemsg); ?>
-
-<?PHP	if ($carp_detected_problems) print_info_box(gettext("CARP has detected a problem and this unit has been demoted to BACKUP status.") . "<br />" . gettext("Check link status on all interfaces with configured CARP VIPs.")); ?>
-
-
-<div id="mainlevel">
-	<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="carp status">
-		<tr>
-			<td>
+<?php if ($savemsg) print_info_box($savemsg)?>
+<?php if ($carp_detected_problems) print_info_box(gettext("CARP has detected a problem and this unit has been demoted to BACKUP status.") . "<br />" . gettext("Check link status on all interfaces with configured CARP VIPs."))?>
 <?php
-			$carpcount = 0;
-			if(is_array($config['virtualip']['vip'])) {
-				foreach($config['virtualip']['vip'] as $carp) {
-					if ($carp['mode'] == "carp") {
-						$carpcount++;
-						break;
-					}
-				}
-			}
-			if($carpcount > 0) {
-				if($status > 0) {
-					$carp_enabled = true;
-					echo "<input type=\"submit\" name=\"disablecarp\" id=\"disablecarp\" value=\"" . gettext("Temporarily Disable CARP") . "\" />";
-				} else {
-					$carp_enabled = false;
-					echo "<input type=\"submit\" name=\"disablecarp\" id=\"disablecarp\" value=\"" . gettext("Enable CARP") . "\" />";
-				}
-				if(isset($config["virtualip_carp_maintenancemode"])) {
-					echo "<input type=\"submit\" name=\"carp_maintenancemode\" id=\"carp_maintenancemode\" value=\"" . gettext("Leave Persistent CARP Maintenance Mode") . "\" />";
-				} else {
-					echo "<input type=\"submit\" name=\"carp_maintenancemode\" id=\"carp_maintenancemode\" value=\"" . gettext("Enter Persistent CARP Maintenance Mode") . "\" />";
-				}
-			}
+$carpcount = 0;
+if(is_array($config['virtualip']['vip'])) {
+	foreach($config['virtualip']['vip'] as $carp) {
+		if ($carp['mode'] == "carp") {
+			$carpcount++;
+			break;
+		}
+	}
+}
+if ($carpcount > 0):
+	$carp_enabled = ($status > 0);
 ?>
-
-			<br/><br/>
-			<table class="tabcont sortable" width="100%" border="0" cellpadding="6" cellspacing="0" summary="results">
-				<tr>
-					<td class="listhdrr" align="center"><?=gettext("CARP Interface"); ?></td>
-					<td class="listhdrr" align="center"><?=gettext("Virtual IP"); ?></td>
-					<td class="listhdrr" align="center"><?=gettext("Status"); ?></td>
-				</tr>
+	<input type="submit" name="disablecarp" value="<?=($carp_enabled ? gettext("Temporarily Disable CARP") : gettext("Enable CARP"))?>" />
+	<input type="submit" name="carp_maintenancemode" value="<?=($config["virtualip_carp_maintenancemode"] ? gettext("Leave Persistent CARP Maintenance Mode") : gettext("Enter Persistent CARP Maintenance Mode"))?>" />
+<?php elseif ($carpcount == 0): ?>
+	<div class="alert alert-info" role="alert">
+		<p>
+			<?=gettext("Could not locate any defined CARP interfaces.")?><br/>
+			<a href="system_hasync.php" class="alert-link"><?=gettext("You can configure high availability sync settings here")?></a>.
+		</p>
+	</div>
+<?php else: ?>
+<table>
+	<tr>
+		<td><?=gettext("CARP Interface")?></td>
+		<td><?=gettext("Virtual IP")?></td>
+		<td><?=gettext("Status")?></td>
+	</tr>
 <?php
-				if ($carpcount == 0) {
-					echo "</table></td></tr></table></div></form><center><br />" . gettext("Could not locate any defined CARP interfaces.");
-					echo "</center>";
-
-					include("fend.inc");
-					echo "</body></html>";
-					return;
-				}
-				if(is_array($config['virtualip']['vip'])) {
-					foreach($config['virtualip']['vip'] as $carp) {
-						if ($carp['mode'] != "carp")
-							continue;
-						$ipaddress = $carp['subnet'];
-						$password = $carp['password'];
-						$netmask = $carp['subnet_bits'];
-						$vhid = $carp['vhid'];
-						$advskew = $carp['advskew'];
-						$advbase = $carp['advbase'];
-						$status = get_carp_interface_status("{$carp['interface']}_vip{$carp['vhid']}");
-						echo "<tr>";
-						$align = "style=\"vertical-align:middle\"";
-						if($carp_enabled == false) {
-							$icon = "<img {$align} src=\"/themes/".$g['theme']."/images/icons/icon_block.gif\" alt=\"disabled\" />";
-							$status = "DISABLED";
-						} else {
-							if($status == "MASTER") {
-								$icon = "<img {$align} src=\"/themes/".$g['theme']."/images/icons/icon_pass.gif\" alt=\"master\" />";
-							} else if($status == "BACKUP") {
-								$icon = "<img {$align} src=\"/themes/".$g['theme']."/images/icons/icon_pass_d.gif\" alt=\"backup\" />";
-							} else if($status == "INIT") {
-								$icon = "<img {$align} src=\"/themes/".$g['theme']."/images/icons/icon_log.gif\" alt=\"init\" />";
-							}
-						}
-						echo "<td class=\"listlr\" align=\"center\">" . convert_friendly_interface_to_friendly_descr($carp['interface']) . "@{$vhid} &nbsp;</td>";
-						echo "<td class=\"listlr\" align=\"center\">" . $ipaddress . "&nbsp;</td>";
-						echo "<td class=\"listlr\" align=\"center\">{$icon}&nbsp;&nbsp;" . $status . "&nbsp;</td>";
-						echo "</tr>";
-					}
-				}
+	foreach($config['virtualip']['vip'] as $carp) {
+		if ($carp['mode'] != "carp")
+			continue;
+		$ipaddress = $carp['subnet'];
+		$password = $carp['password'];
+		$netmask = $carp['subnet_bits'];
+		$vhid = $carp['vhid'];
+		$advskew = $carp['advskew'];
+		$advbase = $carp['advbase'];
+		$status = get_carp_interface_status("{$carp['interface']}_vip{$carp['vhid']}");
+		if($carp_enabled == false) {
+			$icon = 'remove-sign';
+			$status = "DISABLED";
+		} else {
+			if($status == "MASTER") {
+				$icon = 'ok-sign';
+			} else if($status == "BACKUP") {
+				$icon = 'ok-circle';
+			} else if($status == "INIT") {
+				$icon = 'question-sign';
+			}
+		}
 ?>
-			</table>
-			</td>
+	<tr>
+		<td>
+			<td><?=convert_friendly_interface_to_friendly_descr($carp['interface'])?>@<?=$vhid?></td>
+			<td><?=$ipaddress?></td>
+			<td><i class="icon icon-<?=$icon?>">$status</td>
 		</tr>
+<?php }?>
 	</table>
-</div>
 </form>
+<?php endif?>
 
-<p class="vexpl">
-<span class="red"><strong><?=gettext("Note"); ?>:</strong></span>
-<br />
-<?=gettext("You can configure high availability sync settings"); ?> <a href="system_hasync.php"><?=gettext("here"); ?></a>.
-</p>
-
+<h4><?=gettext("pfSync nodes")?></h4>
+<ul>
 <?php
-	echo "<br />" . gettext("pfSync nodes") . ":<br />";
-	echo "<pre>";
-	system("/sbin/pfctl -vvss | /usr/bin/grep creator | /usr/bin/cut -d\" \" -f7 | /usr/bin/sort -u");
-	echo "</pre>";
+	foreach (explode("\n", exec_command("/sbin/pfctl -vvss | /usr/bin/grep creator | /usr/bin/cut -d\" \" -f7 | /usr/bin/sort -u")) as $node)
+		echo '<li>'. $node .'</li>';
 ?>
+</ul>
 
-<?php include("fend.inc"); ?>
+<?php include("fend.inc")?>
 
 </body>
-</html>
+</html>
\ No newline at end of file
diff --git a/usr/local/www/crash_reporter.php b/usr/local/www/crash_reporter.php
index badf663c82..b55315469d 100644
--- a/usr/local/www/crash_reporter.php
+++ b/usr/local/www/crash_reporter.php
@@ -53,29 +53,18 @@ function upload_crash_report($files) {
 		$post["file{$counter}"] = "@{$file}";
 		$counter++;
 	}
-    $ch = curl_init();
-    curl_setopt($ch, CURLOPT_HEADER, 0);
-    curl_setopt($ch, CURLOPT_VERBOSE, 0);
-    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
-    curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");
-    curl_setopt($ch, CURLOPT_URL, $g['crashreporterurl']);
-    curl_setopt($ch, CURLOPT_POST, true);
-    curl_setopt($ch, CURLOPT_POSTFIELDS, $post); 
-    $response = curl_exec($ch);
+	$ch = curl_init();
+	curl_setopt($ch, CURLOPT_HEADER, 0);
+	curl_setopt($ch, CURLOPT_VERBOSE, 0);
+	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
+	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");
+	curl_setopt($ch, CURLOPT_URL, $g['crashreporterurl']);
+	curl_setopt($ch, CURLOPT_POST, true);
+	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
+	$response = curl_exec($ch);
 	return $response;
 }
 
-function output_crash_reporter_html($crash_reports) {
-	echo "<p><strong>" . gettext("Unfortunately we have detected a programming bug.") . "</strong></p>";
-	echo "<p>" . gettext("Would you like to submit the programming debug logs to the pfSense developers for inspection?") . "</p>";
-	echo "<p><i>" . gettext("Please double check the contents to ensure you are comfortable sending this information before clicking Yes.") . "</i></p>";
-	echo "<p>" . gettext("Contents of crash reports") . ":<br />";
-	echo "<textarea readonly=\"readonly\" rows=\"40\" cols=\"65\" name=\"crashreports\">{$crash_reports}</textarea></p>";
-	echo "<p><input name=\"Submit\" type=\"submit\" class=\"formbtn\" value=\"" . gettext("Yes") .  "\" />" . gettext(" - Submit this to the developers for inspection") . "</p>";
-	echo "<p><input name=\"Submit\" type=\"submit\" class=\"formbtn\" value=\"" . gettext("No") .  "\" />" . gettext(" - Just delete the crash report and take me back to the Dashboard") . "</p>";
-	echo "</form>";
-}
-
 $pgtitle = array(gettext("Diagnostics"),gettext("Crash reporter"));
 include('head.inc');
 
@@ -86,15 +75,9 @@ $crash_report_header .= php_uname("v") . "\n";
 $crash_report_header .= "\nCrash report details:\n";
 
 exec("/usr/bin/grep -vi warning /tmp/PHP_errors.log", $php_errors);
-
 ?>
-
-<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
-
-<?php include("fbegin.inc"); ?>
-
-	<form action="crash_reporter.php" method="post">
-
+<body class="crash_reporter">
+<?php include("fbegin.inc")?>
 <?php
 	if (gettext($_POST['Submit']) == "Yes") {
 		echo gettext("Processing...");
@@ -140,14 +123,32 @@ exec("/usr/bin/grep -vi warning /tmp/PHP_errors.log", $php_errors);
 					$crash_reports .= file_get_contents($cf);
 				}
 			}
-		} else { 
+		} else {
 			echo "Could not locate any crash data.";
 		}
-		output_crash_reporter_html($crash_reports);
+?>
+	<div class="jumbotron">
+	<div class="panel panel-default">
+		<div class="panel-heading"><h3><?=gettext("Unfortunately we have detected a programming bug.")?></h3></div>
+		<div class="panel-body">
+		<p>
+			<?=gettext("Would you like to submit the programming debug logs to the pfSense developers for inspection?")?>
+			<i><?=gettext("Please double check the contents to ensure you are comfortable sending this information before clicking Yes.")?></i>
+		</p>
+		<textarea readonly="readonly" style="width: 100%; height: 350px;">
+			<?=$crash_reports?>
+		</textarea>
+		<form action="crash_reporter.php" method="post">
+			<button class="btn btn-primary" name="Submit" type="submit" value="Yes"><?=gettext("Yes")?> - <?=gettext("Submit this to the developers for inspection")?></button>
+			<button class="btn btn-default" name="Submit" type="submit" value="No"><?=gettext("No")?> - <?=gettext("Just delete the crash report and take me back to the Dashboard")?></button>
+		</form>
+	</div>
+	</div>
+<?php
 	}
 ?>
 
-<?php include("fend.inc"); ?>
+<?php include("fend.inc")?>
 
 </body>
-</html>
+</html>
\ No newline at end of file
diff --git a/usr/local/www/diag_arp.php b/usr/local/www/diag_arp.php
index d99b09039e..64d58f2cf9 100644
--- a/usr/local/www/diag_arp.php
+++ b/usr/local/www/diag_arp.php
@@ -3,7 +3,7 @@
 	diag_arp.php
 	part of the pfSense project	(https://www.pfsense.org)
 	Copyright (C) 2004-2009 Scott Ullrich <sullrich@gmail.com>
-        Copyright (C) 2013-2014 Electric Sheep Fencing, LP
+	Copyright (C) 2013-2014 Electric Sheep Fencing, LP
 
 	originally part of m0n0wall (http://m0n0.ch/wall)
 	Copyright (C) 2005 Paul Taylor (paultaylor@winndixie.com) and Manuel Kasper <mk@neon1.net>.
@@ -253,7 +253,7 @@ function _getHostName($mac,$ip) {
 		exec("host -W 1 " . escapeshellarg($ip), $output);
 		if (preg_match('/.*pointer ([A-Za-z0-9.-]+)\..*/',$output[0],$matches)) {
 			if ($matches[1] <> $ip)
-				return $matches[1]; 
+				return $matches[1];
 		}
 	}
 	return "";
@@ -263,29 +263,17 @@ $pgtitle = array(gettext("Diagnostics"),gettext("ARP Table"));
 include("head.inc");
 
 ?>
-
-<body link="#000000" vlink="#000000" alink="#000000">
-
-<?php include("fbegin.inc"); ?>
-
-<div id="loading">
-	<img src="/themes/<?=$g['theme'];?>/images/misc/loader.gif" alt="loader" /><?= gettext("Loading, please wait..."); ?>
-	<p>&nbsp;</p>
-</div>
-
+<body>
+<?php include("fbegin.inc")?>
 <?php
 
-// Flush buffers out to client so that they see Loading, please wait....
-for ($i = 0; $i < ob_get_level(); $i++) { ob_end_flush(); }
-ob_implicit_flush(1);
-
 // Resolve hostnames and replace Z_ with "".  The intention
 // is to sort the list by hostnames, alpha and then the non
 // resolvable addresses will appear last in the list.
 $dnsavailable=1;
-$dns = trim(_getHostName("", "8.8.8.8")); 
+$dns = trim(_getHostName("", "8.8.8.8"));
 if ($dns == ""){
-	$dns = trim(_getHostName("", "8.8.4.4")); 
+	$dns = trim(_getHostName("", "8.8.4.4"));
 	if ($dns == "") $dnsavailable =0;
 }
 
@@ -306,50 +294,38 @@ $data = msort($data, "dnsresolve");
 // Load MAC-Manufacturer table
 $mac_man = load_mac_manufacturer_table();
 ?>
-<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="diag arp">
-	<tr>
-		<td>
-			<table class="tabcont sortable" width="100%" border="0" cellpadding="0" cellspacing="0" summary="tabcont">
-				<tr>
-					<td class="listhdrr"><?= gettext("IP address"); ?></td>
-					<td class="listhdrr"><?= gettext("MAC address"); ?></td>
-					<td class="listhdrr"><?= gettext("Hostname"); ?></td>
-					<td class="listhdr"><?= gettext("Interface"); ?></td>
-					<td class="list"></td>
-				</tr>
-				<?php foreach ($data as $entry): ?>
-					<tr>
-						<td class="listlr"><?=$entry['ip'];?></td>
-						<td class="listr">
-						<?php
-						$mac=trim($entry['mac']);
-						$mac_hi = strtoupper($mac[0] . $mac[1] . $mac[3] . $mac[4] . $mac[6] . $mac[7]);
-						print $mac;
-						if(isset($mac_man[$mac_hi])){ print "<br /><font size=\"-2\"><i>{$mac_man[$mac_hi]}</i></font>"; }
-						?>
-						</td>
-						<td class="listr">
-							<?php
-							echo trim(str_replace("Z_ ", "", $entry['dnsresolve']));
-							?>
-						</td>
-						<td class="listr"><?=$hwif[$entry['interface']];?></td>
-					</tr>
-				<?php endforeach; ?>
-			</table>
-		</td>
-	</tr>
-	<tr>
-		<td><br /><?= gettext("NOTE: Local IPv6 peers use") ?> <a href="diag_ndp.php"><?= gettext("NDP") ?></a> <?= gettext("instead of ARP") ?>.</td>
-	</tr>
+<table class="table table-striped">
+	<thead>
+		<tr>
+			<td><?= gettext("Interface")?></td>
+			<td><?= gettext("IP address")?></td>
+			<td><?= gettext("MAC address")?></td>
+			<td><?= gettext("Hostname")?></td>
+			<td></td>
+		</tr>
+	</thead>
+	<tbody>
+	<?php foreach ($data as $entry): ?>
+		<tr>
+			<td><?=$hwif[$entry['interface']]?></td>
+			<td><?=$entry['ip']?></td>
+			<td>
+				<?=trim($entry['mac'])?>
+			<?php
+				$mac = trim($entry['mac']);
+				$mac_hi = strtoupper($mac[0] . $mac[1] . $mac[3] . $mac[4] . $mac[6] . $mac[7]);
+
+				if (isset($mac_man[$mac_hi]))
+					print '('. $mac_man[$mac_hi] .'(';
+?>
+			</td>
+			<td><?=trim(str_replace("Z_ ", "", $entry['dnsresolve']))?></td>
+		</tr>
+	<?php endforeach?>
+	</tbody>
 </table>
+<p><?= gettext("NOTE: Local IPv6 peers use")?> <a href="diag_ndp.php"><?= gettext("NDP")?></a> <?= gettext("instead of ARP")?>.</p>
 
-<?php include("fend.inc"); ?>
-
-<script type="text/javascript">
-//<![CDATA[
-	jQuery('#loading').html('');
-//]]>
-</script>
+<?php include("fend.inc")?>
 </body>
-</html>
+</html>
\ No newline at end of file
diff --git a/usr/local/www/diag_authentication.php b/usr/local/www/diag_authentication.php
index e7b26dcd29..f03ab98a26 100644
--- a/usr/local/www/diag_authentication.php
+++ b/usr/local/www/diag_authentication.php
@@ -3,7 +3,7 @@
 	diag_authentication.php
 	part of the pfSense project	(https://www.pfsense.org)
 	Copyright (C) 2010 Ermal Luçi
-        Copyright (C) 2013-2014 Electric Sheep Fencing, LP
+	Copyright (C) 2013-2014 Electric Sheep Fencing, LP
 	All rights reserved.
 
 	Redistribution and use in source and binary forms, with or without
@@ -72,61 +72,46 @@ include("head.inc");
 
 ?>
 
-<body link="#000000" vlink="#000000" alink="#000000">
-
-<?php include("fbegin.inc"); ?>
-<?php if ($input_errors) print_input_errors($input_errors);?>
-<?php if ($savemsg) print_info_box($savemsg);?>
-
-<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="diag authentication">
-	<tr>
-		<td class="tabnavtbl"></td>
-	</tr>
-	<tr>
-	<td>
-	<div id="mainarea">
-	<form id="iform" name="iform" action="diag_authentication.php" method="post">
-	<table class="tabcont" width="100%" border="0" cellspacing="0" cellpadding="6" summary="test">
-	<tr>
-		<td width="22%" valign="top" class="vncell"><?=gettext("Authentication Server"); ?></td>
-		<td width="78%" class="vtable">
-			<select name="authmode" id="authmode" class="formselect" >
-			<?php
-				$auth_servers = auth_get_authserver_list();
-				foreach ($auth_servers as $auth_server):
-					$selected = "";
-					if ($auth_server['name'] == $pconfig['authmode'])
-						$selected = "selected=\"selected\"";
-			?>
-			<option value="<?=$auth_server['name'];?>" <?=$selected;?>><?=$auth_server['name'];?></option>
-			<?php   endforeach; ?>
-			</select>
-		</td>
-	</tr>
-	<tr>
-		<td width="22%" valign="top" class="vncell"><?=gettext("Username"); ?></td>
-		<td width="78%" class="vtable">
-			<input class="formfld unknown" size="20" id="username" name="username" value="<?=htmlspecialchars($pconfig['username']);?>" />
-		</td>
-	</tr>
-	<tr>
-		<td width="22%" valign="top" class="vncell"><?=gettext("Password"); ?></td>
-		<td width="78%" class="vtable">
-			<input class="formfld pwd" type="password" size="20" id="password" name="password" value="<?=htmlspecialchars($pconfig['password']);?>" />
-		</td>
-	</tr>
-	<tr>
-		<td width="22%" valign="top">&nbsp;</td>
-		<td width="78%">
-			<input id="save" name="save" type="submit" class="formbtn" value="<?=gettext("Test");?>" />
-		</td>
-	</tr>
-	</table>
-	</form>
+<body>
+<?php include("fbegin.inc")?>
+<?php if ($input_errors) print_input_errors($input_errors)?>
+<?php if ($savemsg) print_info_box($savemsg)?>
+	<div id="container">
+		<form class="form-horizontal" action="diag_authentication.php" method="post">
+			<div class="form-group">
+				<label for="authmode" class="col-sm-2 control-label"><?=gettext("Authentication Server")?></label>
+				<div class="col-sm-10">
+					<select name="authmode" id="authmode" class="formselect" >
+					<?php
+							foreach (auth_get_authserver_list() as $auth_server):
+								$selected = ($auth_server['name'] == $pconfig['authmode'])
+					?>
+						<option value="<?=$auth_server['name']?>" <?=($selected?'selected="selected"':'')?>>
+							<?=$auth_server['name']?>
+						</option>
+					<?php   endforeach?>
+					</select>
+				</div>
+			</div>
+
+			<div class="form-group">
+				<label for="authmode" class="col-sm-2 control-label"><?=gettext("Username")?></label>
+				<div class="col-sm-10">
+					<input name="username" value="<?=htmlspecialchars($pconfig['username'])?>" />
+				</div>
+			</div>
+
+			<div class="form-group">
+				<label for="authmode" class="col-sm-2 control-label"><?=gettext("Password")?></label>
+				<div class="col-sm-10">
+					<input name="password" type="password" value="<?=htmlspecialchars($pconfig['password'])?>" />
+				</div>
+			</div>
+
+			<button type="submit" class="btn btn-primary"><?=gettext("Test");?></button>
+		</form>
 	</div>
-	</td></tr>
-</table>
-
-<?php include("fend.inc"); ?>
+</div>
+<?php include("fend.inc")?>
 </body>
-</html>
+</html>
\ No newline at end of file
